#==============================================================================
# package      DE_EPAGES::Order::UI::LineItem
# state        private
#==============================================================================
package DE_EPAGES::Order::UI::LineItem;
use base DE_EPAGES::Presentation::UI::Object;

use strict;
use DE_EPAGES::Object::API::Factory qw(LoadClassByAlias);

#==============================================================================
# Event handlers
#==============================================================================
sub Delete {
    my $self = shift;
    my $Servlet = shift;
    my $LineItem = $Servlet->object;
    my $Container = $LineItem->container;

    my $OrderDocument = $Container->parent;
    my $OrderDocumentClass = LoadClassByAlias('OrderDocument');
    #set attributes of particular order document
    if ($OrderDocument->instanceOf($OrderDocumentClass) and $OrderDocument->get('Issued')) {
        $Servlet->params('AlreadyIssued',1);
        return $OrderDocument;
    }
    # reset discount flag because we will have an automatic recalculation
    $Container->set({ 'GlobalValueDiscountChanged' => 0 }) if
        $Container->class->existsAttribute('GlobalValueDiscountChanged');
    $LineItem->delete;
    $Container->recalculate;
    $Servlet->params('UpdateNotApplied',1);
    return $Container->parent;
}

1;

