#IF(#ShopVoteScriptCode)
(function () {
    #LOCAL("ParsedScriptCode", #ExtractedShopVoteScriptCode)
        #REM
        /*
         * Use the following code fragment when ShopVote removes the inline code from the a-tag buttons.
         */
        // if ((/epCookieConsent=1/.test(document.cookie) || /cookiefirst-consent=.*functional%22%3Atrue/.test(document.cookie)) && window.eComEventTarget) {
        //     window.eComEventTarget.addEventListener('order:completed', function(event) {
        //         // create script element to load JavaScript source
        //         var script = document.createElement('script');

        //         script.src = '# ParsedScriptCode.Source';
        //         document.body.appendChild(script);

        //         // script source loaded => execute ShopVote code
        //         script.onload = function() {
        //             // script from MBO
        //             # ParsedScriptCode.Code[0]
        //         }
        //     });
        // }
        #ENDREM

        /*
         * The original ShopVote script still uses inline Javascript and this is not allowed in our Content Security Policy (CSP).
         * So with this fix, we replace the inline event handlers with event listeners.
         */
        var adjustCTAButton = function() {
                var noButton = document.querySelector('.srt-button-action-no'),
                    yesButton = document.querySelector('.srt-button-action-yes'),
                    // get parameters from the function call
                    args = noButton.parentNode.innerHTML.match(/stopPopup\(([^)]*)/)[1].split(",");

                // adjust no button
                noButton.removeAttribute("onclick");
                noButton.addEventListener('click', function() {
                    // execute ShopVote function
                    stopPopup(args[0], args[1]);
                });

                // adjust yes button
                yesButton.removeAttribute("onclick");
                yesButton.addEventListener('click', function() {
                    // execute ShopVote function
                    acceptRequest(args[0]);
                });
            },
            shopVoteHTMLCode = function(email, orderNumber) {
                var div = document.createElement('div'),
                    spanEmail = document.createElement('span'),
                    spanCustomer = document.createElement('span');

                spanEmail.id = "srt-customer-email";
                spanEmail.innerHTML = email;
                spanCustomer.id="srt-customer-reference";
                spanCustomer.innerHTML = orderNumber;

                div.id = "srt-customer-data";
                div.style = "display: none;";

                div.appendChild(spanEmail);
                div.appendChild(spanCustomer);

                document.body.appendChild(div);
            },

            script,
            target,
            observer;

        if ((/epCookieConsent=1/.test(document.cookie) || /cookiefirst-consent=.*functional%22%3Atrue/.test(document.cookie)) && window.eComEventTarget) {
            window.eComEventTarget.addEventListener('order:completed', function(event) {
                /*
                 * Polyfill for MutationObserver
                 */
                (function() {
                  var MutationObserver;

                  if (window.MutationObserver != null) {
                    return;
                  }

                  MutationObserver = (function() {
                    function MutationObserver(callBack) {
                      this.callBack = callBack;
                    }

                    MutationObserver.prototype.observe = function(element, options) {
                      this.element = element;
                      return this.interval = setInterval((function(_this) {
                        return function() {
                          var html;
                          html = _this.element.innerHTML;
                          if (html !== _this.oldHtml) {
                            _this.oldHtml = html;
                            return _this.callBack.apply(null, [{polyfill: true, html: html}]);
                          }
                        };
                      })(this), 200);
                    };

                    MutationObserver.prototype.disconnect = function() {
                      return window.clearInterval(this.interval);
                    };

                    return MutationObserver;

                  })();

                  window.MutationObserver = MutationObserver;

                }).call();
                // END - Polyfill

                // create script element to load JavaScript source
                script = document.createElement('script');

                shopVoteHTMLCode(event.detail.billingAddress.emailAddress, event.detail.orderNumber);

                script.src = '#ParsedScriptCode.Source';
                document.body.appendChild(script);

                // script source loaded => execute ShopVote code
                script.onload = function() {
                    // START - MutationObserver
                    // select node to observe
                    target = document.querySelector('body');

                    // create observer instance
                    observer = new MutationObserver(function(mutations) {
                        // polyfill handling
                        if (mutations.polyfill) {
                            if (/shopvote-rating-tool/.test(mutations.html)) {
                                adjustCTAButton();
                                observer.disconnect();
                            }
                        // native observer handling
                        } else {
                            mutations.forEach(function(mutation) {
                                if (mutation.addedNodes[0] && mutation.addedNodes[0].id === "shopvote-rating-tool") {
                                    adjustCTAButton();
                                    observer.disconnect();
                                }
                            });
                        }
                    });

                    // configure observers: check all - changes at data, child nodes, attributes
                    var config = { attributes: true, childList: true, characterData: true };

                    // start observing
                    observer.observe(target, config);

                    // ensure that observer gets disconnected always
                    setTimeout(function() {
                        observer.disconnect();
                    }, 3210);
                    // END - MutationObserver

                    // script from MBO
                    #ParsedScriptCode.Code[0]
                }
            });
        }
    #ENDLOCAL
  })();
#ENDIF
